#include "chip.h"
#include <stdlib.h>


typedef struct {
    int id;
    __IO uint32_t *clk_reg;
    uint32_t clk_msk;
    __IO uint32_t *rst_reg;
    uint32_t rst_msk;
    __IO uint32_t *remap_reg;
    uint32_t remap_msk;
} t_per_regs;

static const t_per_regs f_per_regs[] = {
    {CHIP_PER_ID_DMA1,   &CHIP_REGS_RCC->AHBEN,  CHIP_REGFLD_RCC_AHBEN_DMA1_EN,    NULL, 0,                                                     NULL, 0},
    {CHIP_PER_ID_DMA2,   &CHIP_REGS_RCC->AHBEN,  CHIP_REGFLD_RCC_AHBEN_DMA2_EN,    NULL, 0,                                                     NULL, 0},
    {CHIP_PER_ID_SRAM,   &CHIP_REGS_RCC->AHBEN,  CHIP_REGFLD_RCC_AHBEN_SRAM_EN,    NULL, 0,                                                     NULL, 0},
    {CHIP_PER_ID_FLASH,  &CHIP_REGS_RCC->AHBEN,  CHIP_REGFLD_RCC_AHBEN_FLASH_EN,   NULL, 0,                                                     NULL, 0},
    {CHIP_PER_ID_XMC,    &CHIP_REGS_RCC->AHBEN,  CHIP_REGFLD_RCC_AHBEN_XMC_EN,     NULL, 0,                                                     &CHIP_REGS_AFIO->MAP7, CHIP_REGFLD_AFIO_MAP7_XMC_GRMP},
    {CHIP_PER_ID_AFIO,   &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_AFIO_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_AFIO_RST,   NULL, 0},
    {CHIP_PER_ID_GPIOA,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_GPIOA_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_GPIOA_RST,  NULL, 0},
    {CHIP_PER_ID_GPIOB,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_GPIOB_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_GPIOB_RST,  NULL, 0},
    {CHIP_PER_ID_GPIOC,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_GPIOC_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_GPIOC_RST,  NULL, 0},
    {CHIP_PER_ID_GPIOD,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_GPIOD_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_GPIOD_RST,  NULL, 0},
    {CHIP_PER_ID_GPIOE,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_GPIOE_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_GPIOE_RST,  NULL, 0},
    {CHIP_PER_ID_PWR,    &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_PWR_EN,    &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_PWR_RST,    NULL, 0},
    {CHIP_PER_ID_BKP,    &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_BKP_EN,    &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_BKP_RST,    NULL, 0},
    {CHIP_PER_ID_TMR1,   &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_TMR1_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_TMR1_RST,   &CHIP_REGS_AFIO->MAP4, CHIP_REGFLD_AFIO_MAP4_TMR1_GRMP},
    {CHIP_PER_ID_TMR2,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR2_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR2_RST,   &CHIP_REGS_AFIO->MAP4, CHIP_REGFLD_AFIO_MAP4_TMR2_GRMP},
    {CHIP_PER_ID_TMR3,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR3_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR3_RST,   &CHIP_REGS_AFIO->MAP4, CHIP_REGFLD_AFIO_MAP4_TMR3_GRMP},
    {CHIP_PER_ID_TMR4,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR4_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR4_RST,   &CHIP_REGS_AFIO->MAP4, CHIP_REGFLD_AFIO_MAP4_TMR4_GRMP},
    {CHIP_PER_ID_TMR5,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR5_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR5_RST,   &CHIP_REGS_AFIO->MAP4, CHIP_REGFLD_AFIO_MAP4_TMR5_CH4_IRMP},
    {CHIP_PER_ID_TMR6,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR6_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR6_RST,   NULL, 0},
    {CHIP_PER_ID_TMR7,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR2_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR7_RST,   NULL, 0},
    {CHIP_PER_ID_TMR8,   &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_TMR8_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_TMR8_RST,   NULL, 0},
    {CHIP_PER_ID_TMR9,   &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_TMR9_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_TMR9_RST,   &CHIP_REGS_AFIO->MAP2, CHIP_REGFLD_AFIO_MAP2_TMR9},
    {CHIP_PER_ID_TMR10,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_TMR10_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_TMR10_RST,  NULL, 0},
    {CHIP_PER_ID_TMR11,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_TMR11_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_TMR11_RST,  NULL, 0},
    {CHIP_PER_ID_TMR12,  &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR12_EN,  &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR12_RST,  NULL, 0},
    {CHIP_PER_ID_TMR13,  &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR13_EN,  &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR13_RST,  NULL, 0},
    {CHIP_PER_ID_TMR14,  &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_TMR14_EN,  &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_TMR14_RST,  NULL, 0},
    {CHIP_PER_ID_USART1, &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_USART1_EN, &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_USART1_RST, &CHIP_REGS_AFIO->MAP6, CHIP_REGFLD_AFIO_MAP6_USART1_GRMP},
    {CHIP_PER_ID_USART2, &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_USART2_EN, &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_USART2_RST, &CHIP_REGS_AFIO->MAP6, CHIP_REGFLD_AFIO_MAP6_USART2_GRMP},
    {CHIP_PER_ID_USART3, &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_USART3_EN, &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_USART3_RST, &CHIP_REGS_AFIO->MAP6, CHIP_REGFLD_AFIO_MAP6_USART3_GRMP},
    {CHIP_PER_ID_UART4,  &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_UART4_EN,  &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_UART4_RST,  &CHIP_REGS_AFIO->MAP6, CHIP_REGFLD_AFIO_MAP6_UART4_GRMP},
    {CHIP_PER_ID_UART5,  &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_UART5_EN,  &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_UART5_RST,  &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_UART5_GRMP},
    {CHIP_PER_ID_USART6, &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_USART6_EN, &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_USART6_RST, &CHIP_REGS_AFIO->MAP8, CHIP_REGFLD_AFIO_MAP8_USART6_GRMP},
    {CHIP_PER_ID_UART7,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_UART7_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_UART7_RST,  &CHIP_REGS_AFIO->MAP8, CHIP_REGFLD_AFIO_MAP8_UART7_GRMP},
    {CHIP_PER_ID_UART8,  &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_UART8_EN,  &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_UART8_RST,  &CHIP_REGS_AFIO->MAP8, CHIP_REGFLD_AFIO_MAP8_UART8_GRMP},
    {CHIP_PER_ID_SPI1,   &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_SPI1_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_SPI1_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_SPI1_GRMP},
    {CHIP_PER_ID_SPI2,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_SPI2_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_SPI2_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_SPI2_GRMP},
    {CHIP_PER_ID_SPI3,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_SPI3_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_SPI3_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_SPI3_GRMP},
    {CHIP_PER_ID_SPI4,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_SPI4_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_SPI4_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_SPI4_GRMP},
    {CHIP_PER_ID_I2C1,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_I2C1_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_I2C1_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_I2C1_GRMP},
    {CHIP_PER_ID_I2C2,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_I2C2_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_I2C2_RST,   NULL, 0},
    {CHIP_PER_ID_I2C3,   &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_I2C3_EN,   &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_I2C3_RST,   &CHIP_REGS_AFIO->MAP5, CHIP_REGFLD_AFIO_MAP5_I2C3_GRMP},
    {CHIP_PER_ID_USB,    &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_USB_EN,    &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_USB_RST,    NULL, 0},
    {CHIP_PER_ID_CAN,    &CHIP_REGS_RCC->APB1EN, CHIP_REGFLD_RCC_APB1EN_CAN_EN,    &CHIP_REGS_RCC->APB1RST, CHIP_REGFLD_RCC_APB1RST_CAN_RST,    &CHIP_REGS_AFIO->MAP6, CHIP_REGFLD_AFIO_MAP6_CAN1_GRMP},
    {CHIP_PER_ID_ADC,    &CHIP_REGS_RCC->APB2EN, CHIP_REGFLD_RCC_APB2EN_ADC1_EN,   &CHIP_REGS_RCC->APB2RST, CHIP_REGFLD_RCC_APB2RST_ADC1_RST,   NULL, 0},
};


static const t_per_regs *get_per_regs(int id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_msk;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_msk;
        chip_dsb();
    }
}

void chip_per_clk_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg |= reg->clk_msk;
    }
}

void chip_per_clk_dis(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg &= ~reg->clk_msk;
    }
}

int chip_per_clk_is_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_msk) != 0);
}

void chip_per_pins_remap(int per_id, int remap_num) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->remap_reg) {
        LBITFIELD_UPD(*reg->remap_reg, reg->remap_msk, remap_num);
    }
}
